theory Safety_Proof_Checker
imports 
  Safety_Proof_Parser
  "$AFP/Containers/Set_Impl"
  "$AFP/Derive/Comparator_Generator/Compare_Order_Instances"
begin

definition safety_checker :: "string \<Rightarrow> string + string" where
  "safety_checker input = (case parse_safety_cert_problem input of
     Left e \<Rightarrow> Inl (''error parsing input:\<newline>'' @ e)
   | Right (Safety_Cert_Problem (P,err) cert) \<Rightarrow>
       (case art_safety_checker P err cert of
          Inl e \<Rightarrow> Inl (''error ensuring safety:\<newline>'' @ e [])
        | Inr () \<Rightarrow> Inr (''ensured safety of node '' @ err)))"

end
